#include <stdio.h>
#include "dmmlib/block_header.h"
#include "freelist/block_header_funcs.h"
#include "freelist/linked_lists/search_algorithms.h"
#include "debug.h"

void get_raw_blocks(allocator_t *allocator) {
    int counter;
    raw_block_header_t *current_raw_block;

    current_raw_block = allocator->raw_block_head;
    counter = 0;

    while(current_raw_block) {
        counter++;
        printf("Raw block at %p with remaining size %zu\n",
                (void *)current_raw_block,
                current_raw_block->remaining_size);
        current_raw_block = current_raw_block->next_raw_block;
    }

    printf("There are %d raw blocks\n", counter);

}

void get_memory_blocks(raw_block_header_t *raw_block) {
    block_header_t *memory_block;
    int counter;

    memory_block = raw_block->free_list_head;
    counter = 0;

    while(memory_block) {
        counter++;
        printf("Free memory block at %p with size %zu\n",
                (void *)memory_block, get_size(memory_block));
        memory_block = memory_block->next;
    }

    printf("Raw block at %p has %d memory blocks\n",
            (void *)raw_block, counter);
}
